| IGLib 1.7.2 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events Macros
Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Properties | List of all members
IG.Script.ScriptAppBase Class Reference

Partial class definition containing tests of CSV utilities. More...

Inheritance diagram for IG.Script.ScriptAppBase:
[legend]
Collaboration diagram for IG.Script.ScriptAppBase:
[legend]

## Public Member Functions
void | Script_AddCommands1 (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter. More...
| ScriptAppBase ()
override void | Script_AddCommands (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter. More...
virtual string | RunFileByScript (string filePath)
| Runs all commands that are written in a file. Each line of a file is interpreted as a single command, consisting of command name followed by arguments. More...
virtual void | ReportError (string errorString)
new string | AppMyTest (string[] arguments)
| Test action. More...
override string | AppCustomApp (string[] arguments)
| Custom application. More...
virtual string | AppNumerics (string[] arguments)
| Runs one of the numerics - related embedded applications. More...
virtual string | AppFile (string[] arguments)
| Runs one of the file system - related embedded applications. More...
virtual string | AppCrypto (string[] arguments)
| Runs one of the cryptography - related embedded applications. More...
virtual string | AppSystem (string[] arguments)
| Runs one of the file system - related embedded applications. More...
virtual string | AppAssembly (string[] arguments)
| Runs one of the file assembly - related embedded applications. More...
virtual string | AppProcess (string[] arguments)
| Runs one of the process - related embedded applications. More...
virtual string | AppDataStructures (string[] arguments)
| Runs one of the data structures demo - related embedded applications. More...
Public Member Functions inherited from IG.Script.LoadableScriptSpecialFunctionBase
| LoadableScriptSpecialFunctionBase ()
override void | Script_AddCommand (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings, string commandName, Script_CommandDelegate command, string helpString)
| Adds a new internal script command under specified name to the internal interpreter of the current script object. More...
override void | Script_AddCommands (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter. More...
string | AppMyTest (string[] arguments)
| Test action. More...
Public Member Functions inherited from IG.Lib.LoadableScriptBase
| LoadableScriptBase ()
| Argument-less constructor. If argument-less constructor is called then initialization is not performed and will be performed later. More...
string | Run (string[] arguments)
| Performs the action of this object. Override this in derived classes! More...
void | Initialize (string[] arguments)
| Initializes the object. If not called explicitly, this method is automatically called at the first call to the Run method. More...
virtual string | Script_DefaultInitialize (string[] arguments)
| Default initialization method for scripts. More...
virtual string | Script_DefaultRun (string[] arguments)
| Default run method for the script. Can be used when only installed commands are run by hte script. More...
virtual ICommandLineApplicationInterpreter | Script_CreateInterpreterWithoutCommands ()
| Creates and returns an interpreter that can be used as script's internal interpreter for running script's commands. More...
delegate string | Script_CommandDelegate (string[] args)
| Delegate for commands that are installed on script's internal interpreter (property Script_Interpreter). More...
void | Script_AddCommand (string commandName, Script_CommandDelegate command, string helpString)
| Adds a new internal script command under specified name to the internal interpreter of the current script object. More...
string | Script_GetHelpString (string scriptCommandName)
| Returns help string for internal script command with specified name, or null if help string is not installed for such a command. More...
void | Script_PrintCommandsHelp ()
| Prits help for the installed internal commands of the script. More...
virtual bool | Script_ContainsCommand (string commandName)
| Returns true if the internal script's interpreter contains a command with specified name, false otherwise. More...
virtual bool | Script_ContainsScriptCommand (string commandName)
| Returns true if the specified command is script command (i.e. its first argument is command-name and it is run through the Script_CommandAdapter object). More...
virtual void | Script_RemoveCommand (string commandName)
| Removes the specified internal script command from the internal interpreter of the current scripting object. More...
virtual void | Script_RemoveAllCommands ()
| Removes ALL internal script commands from the internal interpreter of the current scripting object. More...
string | Script_Run (string[] arguments)
| Runs internal script command. More...
string | Script_Run (string commandName, params string[] otherArguments)
| Runs internal script command. More...
virtual void | Script_PrintArguments (string messageString, string[] arguments)
| Prints the specified array of string arguments (usually passed as command-line arguments). More...

## Public Attributes
const string | DataStructuresTestCsvApp = "TestCsv"
const string | DataStructuresTestCsvWriteDefinitionAndData = "CsvWriteDefinitionAndData"
const string | DataStructuresTestCsvReadDefinitionAndData = "CsvReadDefinitionAndData"
new const string | ConstMyTest = "MyTest"
| Name of the command that performs my custom test. More...
new const string | ConstHelpMyTest = "Custom test function."
new const string | ConstCustomApp = "CustomApp"
| Name of the command for custom test. More...
new const string | ConstHelpCustomApp = "Custom aplication."
const string | ConstSystem = "System"
| Name of the command for the system-related embedded applications. More...
const string | ConstHelpSystem = "Various system-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstAssembly = "Assembly"
| Name of the command for the assemblies-related embedded applications. More...
const string | ConstHelpAssembly = "Various assemblies-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstNumerics = "Numerics"
| Name of the command for the numerics-related embedded applications. More...
const string | ConstHelpNumerics = "Various numerics-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstFile = "File"
| Name of the command for the file system-related embedded applications. More...
const string | ConstHelpFile = "Various file system-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstCrypto1 = "Crypto"
| Name of the command for the cryptography-related embedded applications. More...
const string | ConstHelpCrypto = "Various cryptography-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstProcess = "Process"
| Name of the command for the process-related embedded applications. More...
const string | ConstHelpProcess = "Various process-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstDataStructures = "DataStructures"
| Name of the command for the data structures-related embedded applications. More...
const string | ConstHelpDataStructures
const string | ConstRunFile = "RunFileByScript"
| Name of the command that runs (interprets) the specified command file by the script's interpreter. More...
const string | ConstHelpRunFile
const string | NumericsScriptScalarFunction = "ScriptScalarFunction"
const string | FileLogEvents = "LogEvents"
const string | FileWaitCreation = "WaitCreation"
const string | FileRelativePath = "RelativePath"
const string | FileStandardPath = "StandardPath"
const string | FileCurrentDirectory = "CurrentDirectory"
const string | FileCurrentDirectory1 = "SetCurrentDirectory"
const string | CryptoGetFileHash = "GetFileHash"
const string | CryptoCheckSum = "CheckSum"
const string | CryptoEncryptBasic = "EncryptBasic"
const string | CryptoDecryptBasic = "DecryptBasic"
const string | CryptoEncryptPlain = "EncryptPlain"
const string | CryptoDecryptPlain = "DecryptPlain"
const string | CryptoGetKey = "GetKey"
const string | CryptoGetInitializationVector = "GetInitializationVector"
const string | CryptoGetInitializationVector1 = "GetIV"
const string | CryptoGetSalt = "GetSalt"
const string | CryptoTimeKeyGeneration = "TimeKeyGeneration"
const string | CryptoConvert = "Convert"
const string | CryptoAsymKeyInfo = "AsymKeyInfo"
const string | CryptoCertStoreInfo = "CertStoreInfo"
const string | CryptoCertInfo = "CertInfo"
const string | CryptoAddCertificate = "AddCertificate"
const string | CryptoRemoveCertificate = "RemoveCertificate"
const string | CryptoAsymTest = "AsymTest"
const string | CryptoCleanFiles = "CleanFiles"
const string | SystemRuntimeVersion = "RuntimeVersion"
const string | SystemComputerName = "ComputerName"
const string | SystemDomainName = "DomainName"
const string | SystemIpAddress = "IpAddress"
const string | SystemUserName = "UserName"
const string | SystemSystemInfo = "Info"
const string | SystemMACAddress = "MACAddress"
const string | AssemblyInfo = "Info"
const string | AssemblyInfo1 = "AssemblyInfo"
const string | AssemblyResources = "Resources"
const string | AssemblyResources1 = "ResourceInfo"
const string | AssemblyResourcesEmbedded = "ResourcesEmbedded"
const string | AssemblyResourcesResx = "ResourcesResx"
const string | AssemblyReferenced = "ReferencedAssemblies"
const string | AssemblyReferenced1 = "Referenced"
const string | AssemblyLoaded = "LoadedAssemblies"
const string | AssemblyLoaded1 = "Loaded"
const string | AssemblyLoad = "LoadAssemblies"
const string | AssemblyLoad1 = "Load"
const string | AssemblyInfoLoad = "InfoLoadAssemblies"
const string | AssemblyInfoLoad1 = "InfoLoad"
const string | ProcessListProcesses = "ListProcesses"
const string | ProcessListApplications = "ListApplications"
const string | ProcessListApplicationsByWindow = "ListApplicationsByWindow"
const string | ProcessKillProcesses = "KillProcesses"
const string | ProcessKillApplications = "KillApplications"
const string | ProcessKillApplicationsByWindow = "KillApplicationsByWindow"
Public Attributes inherited from IG.Script.LoadableScriptSpecialFunctionBase
const string | ConstMyTest = "MyTest"
| Name of the command that performs my custom test. More...
const string | ConstHelpMyTest = "Custom test function."
const string | ConstCustomApp = "CustomApp"
| Name of the command for custom test. More...
const string | ConstHelpCustomApp = "Custom aplication."
Public Attributes inherited from IG.Lib.LoadableScriptBase
const string | ConstDefaultHelp = "Help"
| Default command name for help. More...
const string | ConstHelpDefaultUniversal = "?"
| Universal name of the help command. More...
const string | ConstDefaultTestScrip = "TestScript"
| Default command name for test method. More...

## Protected Member Functions
virtual void | InitAppDataStructuresPartial ()
| Initializes commands for form demo related utilities (embedded applications). More...
virtual string | DataStructuresFunctionTestCsvApp (string appName, string[] args)
| Executes embedded application - demo application for demonstration of work with CSVs. More...
virtual string | DataStructuresFunctionTestCsvWriteDefinitionAndData (string appName, string[] args)
| Executes embedded application - test of writing sampled data definition and data in CSV format. More...
virtual string | DataStructuresFunctionTestCsvReadDefinitionAndData (string appName, string[] appArgs)
| Executes embedded application - test of writing sampled data definition and data in CSV format. More...
override void | InitializeThis (string[] arguments)
| Initializes the current object. More...
override string | RunThis (string[] arguments)
| Runs action of the current object. More...
void | Script_AddRunFileByScriptCommand (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds the Run comand to the script's interpreter and performs the necessary additional tasks. More...
void | Script_RemoveRunFileByScriptCommand (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Removes the Run comand from the script's interpreter and performs the necessary accompanying tasks. More...
virtual string | AppRunFileByScript (string[] args)
| Execution method that Runs the specified command file by the script's interpreter. More...
void | AddNumericsCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new numerics - related embedded application's command (added as sub-command of the base command named ConstNumerics). More...
virtual string | NumericsFunctionScriptScalarFuncitons (string appName, string[] args)
| Executes embedded application - testing of definition of scalar function objects through expressions. More...
virtual void | InitAppNumerics ()
| Initializes commands for numerics related utilities (embedded applications). More...
virtual string | RunAppNumerics (string[] args)
| Runs a numerics related utility (embedded application) according to arguments. More...
void | AddFileCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new file system - related embedded application's command (added as sub-command of the base command named ConstFile). More...
virtual string | FileFunctionLogEvents (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual string | FileFunctionWaitCreation (string appName, string[] args)
| Executes embedded application - waiting for creation of the specified file. More...
virtual string | FileFunctionRelativePath (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual string | FileFunctionStandardPath (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual string | FileFunctionCurrentDirectory (string appName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory. More...
virtual void | InitAppFile ()
| Initializes commands for file system related utilities (embedded applications). More...
virtual string | RunAppFile (string[] args)
| Runs a file system related utility (embedded application) according to arguments. More...
void | AddCryptoCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new cryptography - related embedded application's command (added as sub-command of the base command named ConstCrypto1). More...
virtual string | CryptoFunctionGetFileHash (string appName, string[] args)
| Executes embedded application - calculation of various hashRet values of a file. More...
virtual string | CryptoFunctionCheckSum (string appName, string[] args)
| Executes embedded application - calculation AND verification of various hashRet values of a file or a string. More...
virtual string | CryptoFunctionEncryptBasic (string appName, string[] args)
| Executes embedded application - symmetric encryption of files, strings, or byte fields by using the BASIC class of methods. More...
virtual string | CryptoFunctionDecryptBasic (string appName, string[] args)
| Executes embedded application - symmetric decryption of files, strings, or byte fields by using the BASIC class of methods. More...
virtual string | CryptoFunctionEncryptPlain (string appName, string[] args)
| Executes embedded application - symmetric encryption of files, strings, or byte fields by using the PLAIN class of methods. More...
virtual string | CryptoFunctionDecryptPlain (string appName, string[] args)
| Executes embedded application - symmetric decryption of files, strings, or byte fields by using the PLAIN class of methods. More...
virtual string | CryptoFunctionGetKey (string appName, string[] args)
| Executes embedded application - generation of secret keys for encryption. More...
virtual string | CryptoFunctionGetInitializationVector (string appName, string[] args)
| Executes embedded application - generation of initialization vectors for encryption. More...
virtual string | CryptoFunctionGetSalt (string appName, string[] args)
| Executes embedded application - generation of salts for encryption. More...
virtual string | CryptoFunctionTimeKeyGeneration (string appName, string[] args)
| Executes embedded application - measuring time of password generaton utilities. More...
virtual string | CryptoFunctionConvert (string appName, string[] args)
| Executes embedded application - conversion between different representations of data. More...
virtual string | CryptoFunctionAsymKeyInfo (string appName, string[] args)
| Executes embedded application - printing infomration about the specified asymmetric key. More...
virtual string | CryptoFunctionCertStoreInfo (string appName, string[] args)
| Executes embedded application - printing infomration about the specified certificate store. More...
virtual string | CryptoFunctionCertInfo (string appName, string[] args)
| Executes embedded application - printing infomration about the specified certificate. More...
virtual string | CryptoFunctionAddCertificate (string appName, string[] args)
| Executes embedded application - adding the specified certificate to the specified certificate store. More...
virtual string | CryptoFunctionRemoveCertificate (string appName, string[] args)
| Executes embedded application - removing the certificate from certificate store. More...
virtual string | CryptoFunctionAsymTest (string appName, string[] args)
| Executes embedded application - test of asymmetric encrypton. More...
virtual string | CryptoFunctionCleanFiles (string appName, string[] args)
| Executes embedded application - conversion between different representations of data. More...
virtual void | InitAppCrypto ()
| Initializes commands for cryptography related utilities (embedded applications). More...
virtual string | RunAppCrypto (string[] args)
| Runs a cryptography related utility (embedded application) according to arguments. More...
virtual string | CryptoFunctionGetFileHash_OLD_TO_DELETE (string appName, string[] args)
| Executes embedded application - calculation of various hashRet values of a file. More...
virtual string | CryptoFunctionCheckSum_OLD_TO_DELETE_LATER (string appName, string[] args)
| Executes embedded application - calculation AND verification of various hashRet values of a file. More...
virtual string | CryptoFunctionTimeKeyGeneration_OLD_TO_DELETE_LATER (string appName, string[] args)
| Executes embedded application - symmetric encryption of files, strings, or byte fields. More...
virtual string | CryptoFunctionConvert_OLD_TO_DELETE (string appName, string[] args)
| Executes embedded application - symmetric encryption of files, strings, or byte fields. More...
void | AddSystemCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new system - related embedded application's command (added as sub-command of the base command named ConstSystem). More...
virtual string | SystemFunctionRuntimeVersion (string appName, string[] args)
| Executes embedded application - writing to the console and returning version of the runtime that application runs on. More...
virtual string | SystemFunctionComputerName (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current computer name. More...
virtual string | SystemFunctionDomainName (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current domain name. More...
virtual string | SystemFunctionIpAddress (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current IP address. More...
virtual string | SystemFunctionUserName (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current user name. More...
virtual string | SystemFunctionSystemInfo (string appName, string[] args)
| Executes embedded application - writing to the console and returning the system info. More...
virtual string | SystemFunctionMACAddress (string appName, string[] args)
| Executes embedded application - writing to the console and returning the current domain name. More...
virtual void | InitAppSystem ()
| Initializes commands for file system related utilities (embedded applications). More...
virtual string | RunAppSystem (string[] args)
| Runs a file system related utility (embedded application) according to arguments. More...
void | AddAssemblyCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new assembly - related embedded application's command (added as sub-command of the base command named ConstSystem). More...
virtual string | AssemblyFunctionInfo (string appName, string[] args)
| Executes embedded application - writing to the console information about the specified assembly. More...
virtual string | AssemblyFunctionResourcesEmbedded (string appName, string[] args)
| Executes embedded application - writing to the console information about the specified assembly's embedded resources. More...
virtual string | AssemblyFunctionResourcesResx (string appName, string[] args)
| Executes embedded application - writing to the console information about the specified assembly's resources included through .resx files. More...
virtual string | AssemblyFunctionResources (string appName, string[] args)
| Executes embedded application - writing to the console information about the specified assembly's resources. More...
virtual string | AssemblyFunctionResources (string appName, string[] args, bool includeEmbedded, bool includeResx)
| Executes embedded application - writing to the console information about the specified assembly's resources. More...
virtual string | AssemblyFunctionReferenced (string appName, string[] args)
| Executes embedded application - writing to the console list of referenced assemblies. More...
virtual string | AssemblyFunctionLoaded (string appName, string[] args)
| Executes embedded application - writing to the console list of loaded assemblies. More...
virtual string | AssemblyFunctionLoadAssemblies (string appName, string[] args)
| Executes embedded application - loading the specified assemblies to the application domain. More...
virtual string | AssemblyFunctionInfoLoadAssemblies (string appName, string[] args)
| Executes embedded application - loading the specified assemblies for inspection only (can not be executed). More...
virtual string | AssemblyFunctionLoadAssemblies (int outputLevel, bool reflectionOnly, string appName, string[] args)
| Executes embedded application - loading the specified assemblies to the application domain. More...
virtual void | InitAppAssembly ()
| Initializes commands for assembly related utilities (embedded applications). More...
virtual string | RunAppAssembly (string[] args)
| Runs a file assembly related utility (embedded application) according to arguments. More...
void | AddProcessCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new process - related embedded application's command (added as sub-command of the base command named ConstProcess). More...
virtual string | ProcessFunctionListProcesses (string appName, string[] args)
| Embedded application - lists all processes that satisfy the specified conditions. More...
virtual string | ProcessFunctionListApplications (string appName, string[] args)
| Embedded application. Lists all running applications sarisfyin specified conditions. More...
virtual string | ProcessFunctionListApplicationsByWindow (string appName, string[] args)
| Embedded application. Lists all running applications sarisfyin specified conditions. More...
virtual string | ProcessFunctionKillProcesses (string appName, string[] args)
| Embedded application - kills all processes that satisfy the specified conditions. More...
virtual string | ProcessFunctionKillApplications (string appName, string[] args)
| Embedded application. Kills all running applications sarisfyin specified conditions. More...
virtual string | ProcessFunctionKillApplicationsByWindow (string appName, string[] args)
| Embedded application. Kills all running applications sarisfyin specified conditions. More...
virtual void | InitAppProcess ()
| Initializes commands for process - related utilities (embedded applications). More...
virtual string | RunAppProcess (string[] args)
| Runs a process - related utility (embedded application) according to arguments. More...
void | AddDataStructuresCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new data structure- related embedded demo application's command (added as a sub-command of the base command named ConstDataStructures). More...
virtual void | InitAppDataStructures ()
| Initializes commands for form demo related utilities (embedded applications). More...
virtual string | RunAppDataStructures (string[] args)
| Runs a data structures demo - related utility (embedded application) according to arguments. More...
Protected Member Functions inherited from IG.Script.LoadableScriptSpecialFunctionBase
override void | InitializeThis (string[] arguments)
| Initializes the current object. More...
override string | RunThis (string[] arguments)
| Runs action of the current object. More...
Protected Member Functions inherited from IG.Lib.LoadableScriptBase
delegate string | CommandMethod (string commandName, string[] args)
| Delegate for internal command methods. More...
ICommandLineApplicationInterpreter | Script_CreateInterpreter ()
| Creates and returns an interpreter that can be used as script's internal interpreter for running script's commands. More...
virtual string | Script_CommandHelp (string[] arguments)
| Prints help. More...
virtual string | Script_CommandTestScript (string[] arguments)
| Prints help. More...

## Protected Attributes
const string | DataStructuresHelpTestCsvApp = DataStructuresTestCsvApp + " : Runs the CSV simple demo application."
const string | DataStructuresHelpTestCsvWriteDefinitionAndData
const string | DataStructuresHelpTestCsvReadDefinitionAndData
bool | _isAddRunFileByScriptCommand = true
List< string > | AppNumericsNames = new List<string>()
| List of installed numerics command names. More...
List< string > | AppNumericsHelpStrings = new List<string>()
| List of help strings corresponding to installed numerics-related commands. More...
List< CommandMethod > | AppNumericsMethods = new List<CommandMethod>()
| List of methods used to perform numerics-related commmands. More...
const string | NumericsHelpScriptScalarFunction = NumericsScriptScalarFunction + " : Definition of scalar functions by expressions."
bool | _appNumericsCommandsInitialized = false
List< string > | AppFileNames = new List<string>()
| List of installed file command names. More...
List< string > | AppFileHelpStrings = new List<string>()
| List of help strings corresponding to installed file commands. More...
List< CommandMethod > | AppFileMethods = new List<CommandMethod>()
| List of methods used to perform file commmands. More...
const string | FileHelpLogEvents = FileLogEvents + " FileOrDirectory MaxEvents : Logs file events for the specified file or directory."
const string | FileHelpWaitCreation = NumericsScriptScalarFunction + " FilePath <ReturnIfExists> : Waits until file is created."
const string | FileHelpRelativePath
const string | FileHelpStandardPath
const string | FileHelpCurrentDirectory
const string | FileHelpCurrentDirectory1
bool | _appFileCommandsInitialized = false
List< string > | AppCryptoNames = new List<string>()
| List of installed cryptographic command names. More...
List< string > | AppCryptoHelpStrings = new List<string>()
| List of help strings corresponding to installed cryptographic commands. More...
List< CommandMethod > | AppCryptoMethods = new List<CommandMethod>()
| List of methods used to perform cryptographic commmands. More...
const string | CryptoHelpGetFileHash
const string | CryptoHelpCheckSum
const string | CryptoHelpDecryptBasic = CryptoDecryptBasic + CryptoHelpEncryptBasicPart
const string | CryptoHelpEncryptBasic = CryptoEncryptBasic + CryptoHelpEncryptBasicPart
const string | CryptoHelpDecryptPlain = CryptoDecryptPlain + CryptoHelpEncryptBasicPart
const string | CryptoHelpEncryptPlain = CryptoEncryptPlain + CryptoHelpEncryptBasicPart
const string | CryptoHelpEncryptBasicPart
const string | CryptoHelpGetKey = CryptoGetKey + CryptoHelpGetKeyLastPart
const string | CryptoHelpGetInitializationVector = CryptoGetInitializationVector + CryptoHelpGetKeyLastPart
const string | CryptoHelpGetInitializationVector1 = CryptoGetInitializationVector1 + CryptoHelpGetKeyLastPart
const string | CryptoHelpGetSalt = CryptoGetSalt + CryptoHelpGetKeyLastPart
const string | CryptoHelpGetKeyLastPart
const string | CryptoHelpTimeKeyGeneration
const string | CryptoHelpConvert
const string | CryptoHelpAsymKeyInfo
const string | CryptoHelpCertStoreInfo
const string | CryptoHelpCertInfo
const string | CryptoHelpAddCertificate
const string | CryptoHelpRemoveCertificate
const string | CryptoHelpAsymTest
const string | CryptoHelpCleanFiles
bool | _appCryptoCommandsInitialized = false
List< string > | AppSystemNames = new List<string>()
| List of installed system related command names. More...
List< string > | AppSystemHelpStrings = new List<string>()
| List of help strings corresponding to installed system related commands. More...
List< CommandMethod > | AppSystemMethods = new List<CommandMethod>()
| List of methods used to perform system related commmands. More...
const string | SystemHelpRuntimeVersion = SystemRuntimeVersion + " : Prints version of the runtime environment that application runs on."
const string | SystemHelpComputerName = SystemComputerName + " : Prints and returns the current computer name."
const string | SystemHelpDomainName = SystemDomainName + " : Prints and returns the current domain name."
const string | SystemHelpIpAddress = SystemIpAddress + " : Prints and returns IP address of the current computer."
const string | SystemHelpUserName = SystemUserName + " : Prints and returns the current user name."
const string | SystemHelpSystemInfo = SystemSystemInfo + " : Prints and returns basic system info."
const string | SystemHelpMACAddress = SystemMACAddress + " : Prints and returns the current domain name."
bool | _appSystemCommandsInitialized = false
List< string > | AppAssemblyNames = new List<string>()
| List of installed assemblies related command names. More...
List< string > | AppAssemblyHelpStrings = new List<string>()
| List of help strings corresponding to installed assembly related commands. More...
List< CommandMethod > | AppAssemblyMethods = new List<CommandMethod>()
| List of methods used to perform assembly related commmands. More...
const string | AssemblyHelpInfo
const string | AssemblyHelpInfo1
const string | AssemblyHelpResources
const string | AssemblyHelpResources1
const string | AssemblyHelpResourcesEmbedded
const string | AssemblyHelpResourcesResx
const string | AssemblyHelpReferenced
const string | AssemblyHelpReferenced1 = AssemblyHelpReferenced
const string | AssemblyHelpLoaded = AssemblyLoaded + @" : Prints all loaded assemblies."
const string | AssemblyHelpLoaded1 = AssemblyHelpLoaded
const string | AssemblyHelpLoad
const string | AssemblyHelpLoad1 = AssemblyHelpLoad
const string | AssemblyHelpInfoLoad
const string | AssemblyHelpInfoLoad1 = AssemblyHelpInfoLoad
bool | _appAssemblyCommandsInitialized = false
List< string > | AppProcessNames = new List<string>()
| List of installed process-related command names. More...
List< string > | AppProcessHelpStrings = new List<string>()
| List of help strings corresponding to installed process commands. More...
List< CommandMethod > | AppProcessMethods = new List<CommandMethod>()
| List of methods used to perform process-related commmands. More...
const string | ProcessHelpListProcesses
const string | ProcessHelpListApplications
const string | ProcessHelpListApplicationsByWindow
const string | ProcessHelpKillProcesses
const string | ProcessHelpKillApplications
const string | ProcessHelpKillApplicationsByWindow
bool | _appProcessCommandsInitialized = false
List< string > | AppDataStructuresNames = new List<string>()
| List of installed data structure - related demo command names. More...
List< string > | AppDataStructuresHelpStrings = new List<string>()
| List of help strings corresponding to the installed data structure - related demo commands. More...
List< CommandMethod > | AppDataStructuresMethods = new List<CommandMethod>()
| List of methods used to perform data structure - related demo commmands. More...
bool | _appDataStructuresCommandsInitialized = false
Protected Attributes inherited from IG.Lib.LoadableScriptBase
string | _embeddedCommandName = null
int | _outputLevel = DefaultOutputLevel
ICommandLineApplicationInterpreter | _script_interpreter

## Properties
virtual bool | IsAddRunFileByScriptCommand`[get, set]`
| Whether or not the Run command is installed on the script's interpreter. More...
Properties inherited from IG.Lib.LoadableScriptBase
string | EmbeddedCommandName`[get, set]`
| Command that was used to launch the current embedded application script. More...
object | Lock`[get]`
| This object's central lock object to be used by other object. Do not use this object for locking in class' methods, for this you should use InternalLock. More...
string[] | InitializationArguments`[get, set]`
| Arguments used by the initialization method. WARNING: arguments can only be set before initialization is performed. Initialization is performed either implicitly at the first call to the Run method or explicitly by calling the Initialize method. More...
virtual bool | IsInitialized`[get, protected set]`
| Whether the object has been initialized or not. More...
static int | DefaultOutputLevel`[get, set]`
int | OutputLevel`[get, set]`
| Level of output to console produced by some operations of the current object. More...
virtual ICommandLineApplicationInterpreter | Script_Interpreter`[get, protected set]`
| Script's internal interpreter that takes care for execution of installed internal commands. More...
SortedList< string, string > | Script_CommandHelpStrings`[get]`
| Contains help strings associated with script commands installed on interpreter. More...
Properties inherited from IG.Lib.ILoadableScript
string | EmbeddedCommandName`[get, set]`
| Command that was used to launch the current embedded application script. More...
string[] | InitializationArguments`[get, set]`
| Arguments used by the initialization method. More...
bool | IsInitialized`[get]`
| Whether the object has been initialized or not. More...
Properties inherited from IG.Lib.ILockable
object | Lock`[get]`

## Detailed Description

Partial class definition containing tests of CSV utilities.

Base cls. for application scripts.

Original class location: ....cs (locate it with "Go to definition" on class name).

The cls.es derived from this cls. are usually used as internal scripts and provide a set of embedded utiliy applications within an application that is based on an command-line interpreter.

Applications will typically extend this cls. by their own specific cls. that is used in its place for providing various embedded utility applications. The base library itself provides the AppBase cls. derived from this cls., which is used because its shorter name. See that cls. for an example how to prepare a derived cls. that will provide as set of embedded applications.

In applications that have the command-line interpreter, embedded applications from this cls. can typically be run in the following way:

AppName Internal IG.Script.AppBase CommandName arg1 arg2 ...

where AppName is the application name, IG.Script.AppBase is the full name of the script cls. that contains embedded applications, CommandName is name of the command thar launches embedded application, and arg1, arg2, etc. are command arguments for the embedded application. In some applications, cls. name may be different and may be a name of a derived cls. that provides extended functionality or just provides a more suitable name of the script.

$A Igor xx Sep12;

## Constructor & Destructor Documentation

IG.Script.ScriptAppBase.ScriptAppBase | ( |  | ) |
| inline

## Member Function Documentation

void IG.Script.ScriptAppBase.Script_AddCommands1 | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  |
| inline

Adds commands to the internal interpreter.

This is the part of adding commands in the partial class.

Parameters

  interpreter | Interpreter where commands are executed.
  helpStrings | List containg help strings.

virtual void IG.Script.ScriptAppBase.InitAppDataStructuresPartial | ( |  | ) |
| inline protected virtual

Initializes commands for form demo related utilities (embedded applications).

virtual string IG.Script.ScriptAppBase.DataStructuresFunctionTestCsvApp | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - demo application for demonstration of work with CSVs.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

virtual string IG.Script.ScriptAppBase.DataStructuresFunctionTestCsvWriteDefinitionAndData | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - test of writing sampled data definition and data in CSV format.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

1st argument: path to the data definition file in JSON.

2nd argument: path to the data file in JSON.

3rd argument: path to the output file where data in CSV is written.

4th argument: whether key and data are in the same row.

5th argument: indentation - number of empty cells before data begins.

All arguments are optional. Relative paths are considered relative to the .../workspaceprojects/00tests/data/sampleddata directory if the workspaceprojects directory can be determined (define the WORKSPACE variable for this).

Returns
  Number of arguments passed.

References IG.Num.SampledDataCsv.DataDefinition, IG.Lib.UtilSystem.GetWorkspaceProjectsDirectoryPath(), IG.Num.SampledDataCsv.Indentation, IG.Num.SampledDataCsv.KeyAndDataInSameRow, IG.Num.SampledDataSet.LoadJson(), IG.Num.InputOutputDataDefiniton.LoadJson(), IG.Lib.StringTable.OutputLevel, IG.Lib.Util.ParseBoolean(), IG.Num.SampledDataCsv.SampledData, IG.Num.SampledDataCsv.SaveDefinitionAndData(), IG.Lib.UtilSystem.StandardizeDirectoryPath(), IG.Lib.StopWatch1.Start(), IG.Lib.StopWatch1.Stop(), and IG.Lib.StopWatch1.TotalTime.

virtual string IG.Script.ScriptAppBase.DataStructuresFunctionTestCsvReadDefinitionAndData | ( | string | appName,
|  | string[] | appArgs
| ) |  |
| inline protected virtual

Executes embedded application - test of writing sampled data definition and data in CSV format.

Parameters

  appName | Name of the embedded application.
  appArgs | Arguments fo the embedded application's command.

1st argument: path to CSV file that contains definitions and data to be read.

2nd argument: path to the file where the read-in definitions and data will be written (in CSV).

3rd argument: if true then key and data are in the same row when writing the data.

4th argument: indentation - number of empty cells before data begins when writing the data.

All arguments are optional. Relative paths are considered relative to the .../workspaceprojects/00tests/data/sampleddata directory if the workspaceprojects directory can be determined (define the WORKSPACE variable for this).

Returns
  Number of arguments passed.

References IG.Num.SampledDataCsv.DataDefinition, IG.Lib.UtilSystem.GetWorkspaceProjectsDirectoryPath(), IG.Num.SampledDataCsv.Indentation, IG.Num.InputOutputDataDefiniton.InputLength, IG.Num.SampledDataCsv.KeyAndDataInSameRow, IG.Num.SampledDataCsv.LoadDefinitionAndData(), IG.Num.InputOutputDataDefiniton.OutputLength, IG.Lib.StringTable.OutputLevel, IG.Lib.Util.ParseBoolean(), IG.Num.SampledDataCsv.SampledData, IG.Num.SampledDataCsv.SaveDefinitionAndData(), IG.Lib.UtilSystem.StandardizeDirectoryPath(), IG.Lib.StopWatch1.Start(), IG.Lib.StopWatch1.Stop(), and IG.Lib.StopWatch1.Time.

override void IG.Script.ScriptAppBase.InitializeThis | ( | string[] | arguments | ) |
| inline protected virtual

Initializes the current object.

Implements IG.Lib.LoadableScriptBase.

override string IG.Script.ScriptAppBase.RunThis | ( | string[] | arguments | ) |
| inline protected virtual

Runs action of the current object.

Parameters

  arguments | Command-line arguments of the action.

Implements IG.Lib.LoadableScriptBase.

override void IG.Script.ScriptAppBase.Script_AddCommands | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  |
| inline virtual

Adds commands to the internal interpreter.

Parameters

  interpreter | Interpreter where commands are executed.
  helpStrings | List containg help strings.

Reimplemented from IG.Lib.LoadableScriptBase.

Reimplemented in IG.Script.AppExtBase.

void IG.Script.ScriptAppBase.Script_AddRunFileByScriptCommand | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  |
| inline protected

Adds the Run comand to the script's interpreter and performs the necessary additional tasks.

The run command runs line by line the specified command file by the script's interpreter.

void IG.Script.ScriptAppBase.Script_RemoveRunFileByScriptCommand | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  |
| inline protected

Removes the Run comand from the script's interpreter and performs the necessary accompanying tasks.

References IG.Lib.ICommandLineApplicationInterpreter.RemoveCommand().

virtual string IG.Script.ScriptAppBase.AppRunFileByScript | ( | string[] | args | ) |
| inline protected virtual

Execution method that Runs the specified command file by the script's interpreter.

Parameters

  args | Command arguments. Command file path must be the only argument.

virtual string IG.Script.ScriptAppBase.RunFileByScript | ( | string | filePath | ) |
| inline virtual

Runs all commands that are written in a file. Each line of a file is interpreted as a single command, consisting of command name followed by arguments.

Parameters

  filePath | Path to the file containing commands.

Returns
  Return value of the last command.

virtual void IG.Script.ScriptAppBase.ReportError | ( | string | errorString | ) |
| inline virtual

new string IG.Script.ScriptAppBase.AppMyTest | ( | string[] | arguments | ) |
| inline

Test action.

Parameters

  arguments | Array of command-line arguments.

override string IG.Script.ScriptAppBase.AppCustomApp | ( | string[] | arguments | ) |
| inline virtual

Custom application.

Reimplemented from IG.Script.LoadableScriptSpecialFunctionBase.

void IG.Script.ScriptAppBase.AddNumericsCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  |
| inline protected

Adds a new numerics - related embedded application's command (added as sub-command of the base command named ConstNumerics).

Parameters

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG.Script.ScriptAppBase.NumericsFunctionScriptScalarFuncitons | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - testing of definition of scalar function objects through expressions.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.ScalarFunctionLoader.Example().

virtual void IG.Script.ScriptAppBase.InitAppNumerics | ( |  | ) |
| inline protected virtual

Initializes commands for numerics related utilities (embedded applications).

virtual string IG.Script.ScriptAppBase.RunAppNumerics | ( | string[] | args | ) |
| inline protected virtual

Runs a numerics related utility (embedded application) according to arguments.

Parameters

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG.Script.ScriptAppBase.AppNumerics | ( | string[] | arguments | ) |
| inline virtual

Runs one of the numerics - related embedded applications.

Parameters

  arguments | Array containing the base command name, application command name and arguments.

void IG.Script.ScriptAppBase.AddFileCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  |
| inline protected

Adds a new file system - related embedded application's command (added as sub-command of the base command named ConstFile).

Parameters

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG.Script.ScriptAppBase.FileFunctionLogEvents | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about file events for the specified file or directory.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.WaitFileEventBase.ExampleWaitEvents().

virtual string IG.Script.ScriptAppBase.FileFunctionWaitCreation | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - waiting for creation of the specified file.

Application blocks until the specified file is created.

The first argument must be path to the file whose creation is waited for.

Optional second argument (boolean) specifies whether function automatically unblocks if the file already exists.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.Util.ParseBoolean(), and IG.Lib.WaitFileCreation.Wait().

virtual string IG.Script.ScriptAppBase.FileFunctionRelativePath | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about file events for the specified file or directory.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetRelativePath().

virtual string IG.Script.ScriptAppBase.FileFunctionStandardPath | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about file events for the specified file or directory.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetStandardizedDirectoryPath().

virtual string IG.Script.ScriptAppBase.FileFunctionCurrentDirectory | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about file events for the specified file or directory.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetStandardizedDirectoryPath(), and IG.Lib.UtilSystem.SetCurrentDirectory().

virtual void IG.Script.ScriptAppBase.InitAppFile | ( |  | ) |
| inline protected virtual

Initializes commands for file system related utilities (embedded applications).

Reimplemented in IG.Script.AppBase.

virtual string IG.Script.ScriptAppBase.RunAppFile | ( | string[] | args | ) |
| inline protected virtual

Runs a file system related utility (embedded application) according to arguments.

Parameters

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG.Script.ScriptAppBase.AppFile | ( | string[] | arguments | ) |
| inline virtual

Runs one of the file system - related embedded applications.

Parameters

  arguments | Array containing the base command name, application command name and arguments.

void IG.Script.ScriptAppBase.AddCryptoCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  |
| inline protected

Adds a new cryptography - related embedded application's command (added as sub-command of the base command named ConstCrypto1).

Parameters

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG.Script.ScriptAppBase.CryptoFunctionGetFileHash | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - calculation of various hashRet values of a file.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppGetFileHash().

virtual string IG.Script.ScriptAppBase.CryptoFunctionCheckSum | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - calculation AND verification of various hashRet values of a file or a string.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppCheckSum().

virtual string IG.Script.ScriptAppBase.CryptoFunctionEncryptBasic | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - symmetric encryption of files, strings, or byte fields by using the BASIC class of methods.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppEncryptSymmetricBasic().

virtual string IG.Script.ScriptAppBase.CryptoFunctionDecryptBasic | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - symmetric decryption of files, strings, or byte fields by using the BASIC class of methods.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppDecryptSymmetricBasic().

virtual string IG.Script.ScriptAppBase.CryptoFunctionEncryptPlain | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - symmetric encryption of files, strings, or byte fields by using the PLAIN class of methods.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppEncryptSymmetricPlain().

virtual string IG.Script.ScriptAppBase.CryptoFunctionDecryptPlain | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - symmetric decryption of files, strings, or byte fields by using the PLAIN class of methods.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppDecryptSymmetricPlain().

virtual string IG.Script.ScriptAppBase.CryptoFunctionGetKey | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - generation of secret keys for encryption.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppGetKey().

virtual string IG.Script.ScriptAppBase.CryptoFunctionGetInitializationVector | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - generation of initialization vectors for encryption.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppGetInitializationVector().

virtual string IG.Script.ScriptAppBase.CryptoFunctionGetSalt | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - generation of salts for encryption.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppGetSalt().

virtual string IG.Script.ScriptAppBase.CryptoFunctionTimeKeyGeneration | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - measuring time of password generaton utilities.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppTimeKeyGeneration().

virtual string IG.Script.ScriptAppBase.CryptoFunctionConvert | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - conversion between different representations of data.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppConvert().

virtual string IG.Script.ScriptAppBase.CryptoFunctionAsymKeyInfo | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - printing infomration about the specified asymmetric key.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppAsymKeyInfo().

virtual string IG.Script.ScriptAppBase.CryptoFunctionCertStoreInfo | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - printing infomration about the specified certificate store.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppCertStoreInfo().

virtual string IG.Script.ScriptAppBase.CryptoFunctionCertInfo | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - printing infomration about the specified certificate.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppCertInfo().

virtual string IG.Script.ScriptAppBase.CryptoFunctionAddCertificate | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - adding the specified certificate to the specified certificate store.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppAddCertificate().

virtual string IG.Script.ScriptAppBase.CryptoFunctionRemoveCertificate | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - removing the certificate from certificate store.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppRemoveCertificate().

virtual string IG.Script.ScriptAppBase.CryptoFunctionAsymTest | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - test of asymmetric encrypton.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppAsymTest().

virtual string IG.Script.ScriptAppBase.CryptoFunctionCleanFiles | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - conversion between different representations of data.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.CryptoManager.AppCleanFiles().

virtual void IG.Script.ScriptAppBase.InitAppCrypto | ( |  | ) |
| inline protected virtual

Initializes commands for cryptography related utilities (embedded applications).

Reimplemented in IG.Script.AppExtBase.

virtual string IG.Script.ScriptAppBase.RunAppCrypto | ( | string[] | args | ) |
| inline protected virtual

Runs a cryptography related utility (embedded application) according to arguments.

Parameters

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG.Script.ScriptAppBase.AppCrypto | ( | string[] | arguments | ) |
| inline virtual

Runs one of the cryptography - related embedded applications.

Parameters

  arguments | Array containing the base command name, application command name and arguments.

virtual string IG.Script.ScriptAppBase.CryptoFunctionGetFileHash_OLD_TO_DELETE | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - calculation of various hashRet values of a file.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.UtilCrypto.GetFileHashMd5Hex(), IG.Crypto.UtilCrypto.GetFileHashSha1Hex(), IG.Crypto.UtilCrypto.GetFileHashSha256Hex(), IG.Crypto.UtilCrypto.GetFileHashSha512Hex(), IG.Lib.UtilConsole.Read(), and IG.Lib.UtilStr.ToBoolean().

virtual string IG.Script.ScriptAppBase.CryptoFunctionCheckSum_OLD_TO_DELETE_LATER | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - calculation AND verification of various hashRet values of a file.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Crypto.UtilCrypto.CheckFileHashHex(), IG.Crypto.UtilCrypto.CheckStringHashHex(), IG.Lib.UtilSystem.GetAbsolutePath(), IG.Crypto.UtilCrypto.GetFileHashHex(), IG.Crypto.UtilCrypto.GetHashType(), IG.Lib.UtilSystem.GetRelativePath(), IG.Crypto.UtilCrypto.GetStringHashHex(), IG.Lib.UtilSystem.ListFilesByLevels(), IG.Lib.UtilSystem.ListFilesRecursively(), IG.Crypto.UtilCrypto.ParseHashFile(), and IG.Lib.UtilConsole.Read().

virtual string IG.Script.ScriptAppBase.CryptoFunctionTimeKeyGeneration_OLD_TO_DELETE_LATER | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - symmetric encryption of files, strings, or byte fields.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Lib.Util.FromHexString(), IG.Crypto.PasswordAlgorithmBase.GetBytes(), IG.Crypto.UtilCrypto.GetPasswordAlgorithm(), IG.Crypto.UtilCrypto.GetPasswordAlgorithmType(), IG.Crypto.UtilCrypto.GetRandomBytes(), IG.Crypto.PasswordAlgorithmBase.Init(), IG.Crypto.UtilCrypto.StringEncoding, and IG.Lib.StopWatch1.TestExecutionTime().

virtual string IG.Script.ScriptAppBase.CryptoFunctionConvert_OLD_TO_DELETE | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - symmetric encryption of files, strings, or byte fields.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

References IG.Lib.Util.FromHexString(), IG.Lib.Util.ToByteArray(), and IG.Lib.Util.ToHexString().

void IG.Script.ScriptAppBase.AddSystemCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  |
| inline protected

Adds a new system - related embedded application's command (added as sub-command of the base command named ConstSystem).

Parameters

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG.Script.ScriptAppBase.SystemFunctionRuntimeVersion | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console and returning version of the runtime that application runs on.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetRuntimeVersionString().

virtual string IG.Script.ScriptAppBase.SystemFunctionComputerName | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console and returning the current computer name.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetComputerName().

virtual string IG.Script.ScriptAppBase.SystemFunctionDomainName | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console and returning the current domain name.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetDomainName().

virtual string IG.Script.ScriptAppBase.SystemFunctionIpAddress | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console and returning the current IP address.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetIpAddressLocal().

virtual string IG.Script.ScriptAppBase.SystemFunctionUserName | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console and returning the current user name.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.UserName.

virtual string IG.Script.ScriptAppBase.SystemFunctionSystemInfo | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console and returning the system info.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetSystemInfoString().

virtual string IG.Script.ScriptAppBase.SystemFunctionMACAddress | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console and returning the current domain name.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetMacAddressFastest().

virtual void IG.Script.ScriptAppBase.InitAppSystem | ( |  | ) |
| inline protected virtual

Initializes commands for file system related utilities (embedded applications).

virtual string IG.Script.ScriptAppBase.RunAppSystem | ( | string[] | args | ) |
| inline protected virtual

Runs a file system related utility (embedded application) according to arguments.

Parameters

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG.Script.ScriptAppBase.AppSystem | ( | string[] | arguments | ) |
| inline virtual

Runs one of the file system - related embedded applications.

Parameters

  arguments | Array containing the base command name, application command name and arguments.

void IG.Script.ScriptAppBase.AddAssemblyCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  |
| inline protected

Adds a new assembly - related embedded application's command (added as sub-command of the base command named ConstSystem).

Parameters

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG.Script.ScriptAppBase.AssemblyFunctionInfo | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about the specified assembly.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetAssemblyByFileName(), IG.Lib.UtilSystem.GetAssemblyByName(), IG.Lib.UtilSystem.GetAssemblyInfo(), IG.Lib.UtilSystem.IglibAssembly, and IG.Lib.Util.TryParseBoolean().

virtual string IG.Script.ScriptAppBase.AssemblyFunctionResourcesEmbedded | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about the specified assembly's embedded resources.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  A line-separated list of resource identifiers.

virtual string IG.Script.ScriptAppBase.AssemblyFunctionResourcesResx | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about the specified assembly's resources included through .resx files.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns

  A line-separated list of resource identifiers.

  For .resx-included resources, resources have the form resFileName:resName (fully qualified resource file name including the .resources extension, plus name of a particular resource).

virtual string IG.Script.ScriptAppBase.AssemblyFunctionResources | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about the specified assembly's resources.

Information about embedded resources as well as resources included via .resx file is written.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns

  A line-separated list of resource identifiers.

  For .resx-included resources, resources have the form resFileName:resName (fully qualified resource file name including the .resources extension, plus name of a particular resource).

virtual string IG.Script.ScriptAppBase.AssemblyFunctionResources | ( | string | appName,
|  | string[] | args,
|  | bool | includeEmbedded,
|  | bool | includeResx
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console information about the specified assembly's resources.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.
  includeEmbedded | Specifies whether embedded resources are included in the report.
  includeResx | Specifies whether rerources from .resources files (compiled through .resx filles) are included in the report.

Returns

  A line-separated list of resource identifiers.

  For .resx-included resources, resources have the form resFileName:resName (fully qualified resource file name including the .resources extension, plus name of a particular resource).

References IG.Lib.UtilSystem.GetAssemblyByFileName(), IG.Lib.UtilSystem.GetAssemblyByName(), IG.Lib.UtilSystem.GetAssemblyResourcesInfo(), IG.Lib.UtilSystem.IglibAssembly, and IG.Lib.Util.TryParseBoolean().

virtual string IG.Script.ScriptAppBase.AssemblyFunctionReferenced | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console list of referenced assemblies.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetAssemblyName(), IG.Lib.UtilSystem.GetAssemblyVersion(), IG.Lib.UtilSystem.GetReferencedAssemblies(), IG.Lib.UtilSystem.GetReferencedAssembliesRecursive(), IG.Lib.UtilSystem.GetReferencedAssembliesRecursiveWithoutGac(), IG.Lib.UtilSystem.GetReferencedAssembliesWithoutGac(), and IG.Lib.Util.TryParseBoolean().

virtual string IG.Script.ScriptAppBase.AssemblyFunctionLoaded | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - writing to the console list of loaded assemblies.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetAssemblyName(), IG.Lib.UtilSystem.GetAssemblyVersion(), and IG.Lib.UtilSystem.GetLoadedAssemblies().

virtual string IG.Script.ScriptAppBase.AssemblyFunctionLoadAssemblies | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - loading the specified assemblies to the application domain.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

virtual string IG.Script.ScriptAppBase.AssemblyFunctionInfoLoadAssemblies | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - loading the specified assemblies for inspection only (can not be executed).

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

virtual string IG.Script.ScriptAppBase.AssemblyFunctionLoadAssemblies | ( | int | outputLevel,
|  | bool | reflectionOnly,
|  | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Executes embedded application - loading the specified assemblies to the application domain.

Parameters

  outputLevel | Level of output.
  reflectionOnly | If true then assemblies are loaded for inspection only.
  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of arguments passed.

References IG.Lib.UtilSystem.GetAssemblyName(), IG.Lib.UtilSystem.GetAssemblyVersion(), and IG.Lib.UtilSystem.LoadAssemblies().

virtual void IG.Script.ScriptAppBase.InitAppAssembly | ( |  | ) |
| inline protected virtual

Initializes commands for assembly related utilities (embedded applications).

virtual string IG.Script.ScriptAppBase.RunAppAssembly | ( | string[] | args | ) |
| inline protected virtual

Runs a file assembly related utility (embedded application) according to arguments.

Parameters

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG.Script.ScriptAppBase.AppAssembly | ( | string[] | arguments | ) |
| inline virtual

Runs one of the file assembly - related embedded applications.

Parameters

  arguments | Array containing the base command name, application command name and arguments.

void IG.Script.ScriptAppBase.AddProcessCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  |
| inline protected

Adds a new process - related embedded application's command (added as sub-command of the base command named ConstProcess).

Parameters

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG.Script.ScriptAppBase.ProcessFunctionListProcesses | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Embedded application - lists all processes that satisfy the specified conditions.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of processes.

References IG.Lib.UtilSystem.GetAllProcesses(), IG.Lib.UtilSystem.GetProcesses(), and IG.Lib.Util.ParseBoolean().

virtual string IG.Script.ScriptAppBase.ProcessFunctionListApplications | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Embedded application. Lists all running applications sarisfyin specified conditions.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of processes.

References IG.Lib.UtilSystem.GetAllApplications(), IG.Lib.UtilSystem.GetApplications(), and IG.Lib.Util.ParseBoolean().

virtual string IG.Script.ScriptAppBase.ProcessFunctionListApplicationsByWindow | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Embedded application. Lists all running applications sarisfyin specified conditions.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of processes.

References IG.Lib.UtilSystem.GetAllApplications(), IG.Lib.UtilSystem.GetApplicationsByWindowTitle(), and IG.Lib.Util.ParseBoolean().

virtual string IG.Script.ScriptAppBase.ProcessFunctionKillProcesses | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Embedded application - kills all processes that satisfy the specified conditions.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of processes.

References IG.Lib.UtilSystem.GetProcesses(), and IG.Lib.Util.ParseBoolean().

virtual string IG.Script.ScriptAppBase.ProcessFunctionKillApplications | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Embedded application. Kills all running applications sarisfyin specified conditions.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of processes.

References IG.Lib.UtilSystem.GetApplications(), and IG.Lib.Util.ParseBoolean().

virtual string IG.Script.ScriptAppBase.ProcessFunctionKillApplicationsByWindow | ( | string | appName,
|  | string[] | args
| ) |  |
| inline protected virtual

Embedded application. Kills all running applications sarisfyin specified conditions.

Parameters

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns
  Number of processes.

References IG.Lib.UtilSystem.GetApplicationsByWindowTitle(), and IG.Lib.Util.ParseBoolean().

virtual void IG.Script.ScriptAppBase.InitAppProcess | ( |  | ) |
| inline protected virtual

Initializes commands for process - related utilities (embedded applications).

virtual string IG.Script.ScriptAppBase.RunAppProcess | ( | string[] | args | ) |
| inline protected virtual

Runs a process - related utility (embedded application) according to arguments.

Parameters

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG.Script.ScriptAppBase.AppProcess | ( | string[] | arguments | ) |
| inline virtual

Runs one of the process - related embedded applications.

Parameters

  arguments | Array containing the base command name, application command name and arguments.

void IG.Script.ScriptAppBase.AddDataStructuresCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  |
| inline protected

Adds a new data structure- related embedded demo application's command (added as a sub-command of the base command named ConstDataStructures).

Parameters

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual void IG.Script.ScriptAppBase.InitAppDataStructures | ( |  | ) |
| inline protected virtual

Initializes commands for form demo related utilities (embedded applications).

virtual string IG.Script.ScriptAppBase.RunAppDataStructures | ( | string[] | args | ) |
| inline protected virtual

Runs a data structures demo - related utility (embedded application) according to arguments.

Parameters

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and the rest are arguments that are used by the embedded application.

virtual string IG.Script.ScriptAppBase.AppDataStructures | ( | string[] | arguments | ) |
| inline virtual

Runs one of the data structures demo - related embedded applications.

Parameters

  arguments | Array containing the base command name, application command name and arguments.

## Member Data Documentation

const string IG.Script.ScriptAppBase.DataStructuresTestCsvApp = "TestCsv"

const string IG.Script.ScriptAppBase.DataStructuresHelpTestCsvApp = DataStructuresTestCsvApp + " : Runs the CSV simple demo application."
| protected

const string IG.Script.ScriptAppBase.DataStructuresTestCsvWriteDefinitionAndData = "CsvWriteDefinitionAndData"

const string IG.Script.ScriptAppBase.DataStructuresHelpTestCsvWriteDefinitionAndData
| protected

Initial value:
= DataStructuresTestCsvWriteDefinitionAndData +
@" <defFile> <dataFile> <outFile> <sameRow> <indentation> ... : Tests writing of sampled data definition and data itself to CSV.
defFile: path to JSON file that contains definitions of input and output data elements
dataFile: JSON file that contains the data
outFile: path to the file where data in CSV is written
sameRow: if true then key and data are in the same row
indentation: number of empty cells before data begins
Relative paths are relative to the .../workspaceprojects/00tests/data/sampleddata directory
when the workspaceprojects directory is defined (define its path with the WORKSPACE
system variable!)."

const string IG.Script.ScriptAppBase.DataStructuresTestCsvReadDefinitionAndData = "CsvReadDefinitionAndData"

const string IG.Script.ScriptAppBase.DataStructuresHelpTestCsvReadDefinitionAndData
| protected

Initial value:
= DataStructuresTestCsvReadDefinitionAndData +
@" <inputFile> <outputFile> <sameRow> <indentation> ... : Tests reading of sampled data definition and data itself from CSV.
inputFile: path to CSV file that contains definitions and data to be read (default: neuraldefinitionanddata.csv)
outputFile: path to the file where the read-in definitions and data will be written in CSV (default: testdata/ReadAndWritten.csv)
sameRow: if true then key and data are in the same row when writing the data
indentation: number of empty cells before data begins when writing the data
Relative paths are relative to the .../workspaceprojects/00tests/data/sampleddata directory
when the workspaceprojects directory is defined (define its path with the WORKSPACE
system variable!)."

new const string IG.Script.ScriptAppBase.ConstMyTest = "MyTest"

Name of the command that performs my custom test.

new const string IG.Script.ScriptAppBase.ConstHelpMyTest = "Custom test function."

new const string IG.Script.ScriptAppBase.ConstCustomApp = "CustomApp"

Name of the command for custom test.

new const string IG.Script.ScriptAppBase.ConstHelpCustomApp = "Custom aplication."

const string IG.Script.ScriptAppBase.ConstSystem = "System"

Name of the command for the system-related embedded applications.

const string IG.Script.ScriptAppBase.ConstHelpSystem = "Various system-related embedded applications. Run with ? argument to see which applications are available."

const string IG.Script.ScriptAppBase.ConstAssembly = "Assembly"

Name of the command for the assemblies-related embedded applications.

const string IG.Script.ScriptAppBase.ConstHelpAssembly = "Various assemblies-related embedded applications. Run with ? argument to see which applications are available."

const string IG.Script.ScriptAppBase.ConstNumerics = "Numerics"

Name of the command for the numerics-related embedded applications.

const string IG.Script.ScriptAppBase.ConstHelpNumerics = "Various numerics-related embedded applications. Run with ? argument to see which applications are available."

const string IG.Script.ScriptAppBase.ConstFile = "File"

Name of the command for the file system-related embedded applications.

const string IG.Script.ScriptAppBase.ConstHelpFile = "Various file system-related embedded applications. Run with ? argument to see which applications are available."

const string IG.Script.ScriptAppBase.ConstCrypto1 = "Crypto"

Name of the command for the cryptography-related embedded applications.

const string IG.Script.ScriptAppBase.ConstHelpCrypto = "Various cryptography-related embedded applications. Run with ? argument to see which applications are available."

const string IG.Script.ScriptAppBase.ConstProcess = "Process"

Name of the command for the process-related embedded applications.

const string IG.Script.ScriptAppBase.ConstHelpProcess = "Various process-related embedded applications. Run with ? argument to see which applications are available."

const string IG.Script.ScriptAppBase.ConstDataStructures = "DataStructures"

Name of the command for the data structures-related embedded applications.

const string IG.Script.ScriptAppBase.ConstHelpDataStructures

Initial value:
=
@"Various data structures-related embedded demo applications.
Run with the '?' argument to see which applications are available."

const string IG.Script.ScriptAppBase.ConstRunFile = "RunFileByScript"

Name of the command that runs (interprets) the specified command file by the script's interpreter.

const string IG.Script.ScriptAppBase.ConstHelpRunFile

Initial value:
=
ConstRunFile + @" commandFile : Runs (interprets) the specified file by the script's interpreter.
commandFile: path to the command file that is interpreted (usual extension: '.cmd')."

bool IG.Script.ScriptAppBase._isAddRunFileByScriptCommand = true
| protected

List<string> IG.Script.ScriptAppBase.AppNumericsNames = new List<string>()
| protected

List of installed numerics command names.

List<string> IG.Script.ScriptAppBase.AppNumericsHelpStrings = new List<string>()
| protected

List of help strings corresponding to installed numerics-related commands.

List<CommandMethod> IG.Script.ScriptAppBase.AppNumericsMethods = new List<CommandMethod>()
| protected

List of methods used to perform numerics-related commmands.

const string IG.Script.ScriptAppBase.NumericsScriptScalarFunction = "ScriptScalarFunction"

const string IG.Script.ScriptAppBase.NumericsHelpScriptScalarFunction = NumericsScriptScalarFunction + " : Definition of scalar functions by expressions."
| protected

bool IG.Script.ScriptAppBase._appNumericsCommandsInitialized = false
| protected

List<string> IG.Script.ScriptAppBase.AppFileNames = new List<string>()
| protected

List of installed file command names.

List<string> IG.Script.ScriptAppBase.AppFileHelpStrings = new List<string>()
| protected

List of help strings corresponding to installed file commands.

List<CommandMethod> IG.Script.ScriptAppBase.AppFileMethods = new List<CommandMethod>()
| protected

List of methods used to perform file commmands.

const string IG.Script.ScriptAppBase.FileLogEvents = "LogEvents"

const string IG.Script.ScriptAppBase.FileHelpLogEvents = FileLogEvents + " FileOrDirectory MaxEvents : Logs file events for the specified file or directory."
| protected

const string IG.Script.ScriptAppBase.FileWaitCreation = "WaitCreation"

const string IG.Script.ScriptAppBase.FileHelpWaitCreation = NumericsScriptScalarFunction + " FilePath <ReturnIfExists> : Waits until file is created."
| protected

const string IG.Script.ScriptAppBase.FileRelativePath = "RelativePath"

const string IG.Script.ScriptAppBase.FileHelpRelativePath
| protected

Initial value:
= FileRelativePath + " Path <InitilPath> : Gets the relative path of Path with respect to InitialPath."
+ "\n" + " If InitilPath is not specified then the current directory is taken."

const string IG.Script.ScriptAppBase.FileStandardPath = "StandardPath"

const string IG.Script.ScriptAppBase.FileHelpStandardPath
| protected

Initial value:
= FileStandardPath + " <DirectoryPath> : Gets the standardized path of DirectoryPath."
+ "\n" + " If DirectoryPath is not specified then the current directory is taken."

const string IG.Script.ScriptAppBase.FileCurrentDirectory = "CurrentDirectory"

const string IG.Script.ScriptAppBase.FileCurrentDirectory1 = "SetCurrentDirectory"

const string IG.Script.ScriptAppBase.FileHelpCurrentDirectory
| protected

Initial value:
= FileCurrentDirectory + " <DirectoryPath> : Sets the current directory to DirectoryPath."
+ "\n" + " If DirectoryPath is not specified then the path of the current directory is printed."

const string IG.Script.ScriptAppBase.FileHelpCurrentDirectory1
| protected

Initial value:
= FileCurrentDirectory1 + " <DirectoryPath> : Sets the current directory to DirectoryPath."
+ "\n" + " If DirectoryPath is not specified then the path of the current directory is printed."

bool IG.Script.ScriptAppBase._appFileCommandsInitialized = false
| protected

List<string> IG.Script.ScriptAppBase.AppCryptoNames = new List<string>()
| protected

List of installed cryptographic command names.

List<string> IG.Script.ScriptAppBase.AppCryptoHelpStrings = new List<string>()
| protected

List of help strings corresponding to installed cryptographic commands.

List<CommandMethod> IG.Script.ScriptAppBase.AppCryptoMethods = new List<CommandMethod>()
| protected

List of methods used to perform cryptographic commmands.

const string IG.Script.ScriptAppBase.CryptoGetFileHash = "GetFileHash"

const string IG.Script.ScriptAppBase.CryptoHelpGetFileHash
| protected

Initial value:
= CryptoGetFileHash +
@" FilePath <WriteToFile>: Calculates various hash values for the specified file, and eventually saves them to a file.
FilePath: path to the file whose hash values are calculated.
WriteToFile (0/1 or on/off or true/false, default false): whether hash values are written to a file. The file
will have the same name as the hashed file, with extension .chk added."

const string IG.Script.ScriptAppBase.CryptoCheckSum = "CheckSum"

const string IG.Script.ScriptAppBase.CryptoHelpCheckSum
| protected

Initial value:
= CryptoCheckSum +
@" <-c> <-s string> <-h hash> <-t hashType> <-o outputFile> <-rd directory> <-rp pattern> <-rl> levels <inputFile1> <inputFile2> ...:
Calculates or verifies various types of hash values for files or strings. Calculated file hashes
can be saved to a file.
-t hashType: specifies hash type (MD5, SHA-1, SHA-256, SHA-512)
-c: verification rather than calculation of hashes.
-s: hash is calculated or verified for the specified string rather than file(s).
-h hash: hash value to be verified.
-o outputFile: output file where calculated hashes are written.
-rd directoryPath - input files are recursively searched for in the specified path. Option can be repeated several times.
-rl levels - number of directory levels that are recursively searched for files (the rd option)
-rp filePattern - file search pattern to be added to the recursive directory search (such as "".txt\"").
Option can be repeated several times. If not specified then all files are searched for recursively when -rd is present.
inputFile1 inputFile2 ...: input files, either files whose hashes are calculated, or files
containing hash values to be verified (in the case of -c option). Wildcard patterns can be used."

const string IG.Script.ScriptAppBase.CryptoEncryptBasic = "EncryptBasic"

const string IG.Script.ScriptAppBase.CryptoDecryptBasic = "DecryptBasic"

const string IG.Script.ScriptAppBase.CryptoEncryptPlain = "EncryptPlain"

const string IG.Script.ScriptAppBase.CryptoDecryptPlain = "DecryptPlain"

const string IG.Script.ScriptAppBase.CryptoHelpDecryptBasic = CryptoDecryptBasic + CryptoHelpEncryptBasicPart
| protected

const string IG.Script.ScriptAppBase.CryptoHelpEncryptBasic = CryptoEncryptBasic + CryptoHelpEncryptBasicPart
| protected

const string IG.Script.ScriptAppBase.CryptoHelpDecryptPlain = CryptoDecryptPlain + CryptoHelpEncryptBasicPart
| protected

const string IG.Script.ScriptAppBase.CryptoHelpEncryptPlain = CryptoEncryptPlain + CryptoHelpEncryptBasicPart
| protected

const string IG.Script.ScriptAppBase.CryptoHelpEncryptBasicPart
| protected

Initial value:
=
@" <-c> <-pws pwdString> <-sls saltString> <-s string> <-b bytes> <-t encryptionType> <-o outputFile> <inputFile1> <inputFile2> ...:
Performs symmetric encription or decryption of files, strings, and byte sequences. Encrypted content can be saved to a file.
-t hashType: specifies hash type (MD5, SHA-1, SHA-256, SHA-512)
-c: verification rather than calculation of hashes.
-s: hash is calculated or verified for the specified string rather than file(s).
-h hash: hash value to be verified.
-o outputFile: output file where calculated hashes are written.
-rd directoryPath - input files are recursively searched for in the specified path. Option can be repeated several times.
-rl levels - number of directory levels that are recursively searched for files (the rd option)
-rp filePattern - file search pattern to be added to the recursive directory search (such as "".txt\"").
Option can be repeated several times. If not specified then all files are searched for recursively when -rd is present.
inputFile1 inputFile2 ...: input files, either files whose hashes are calculated, or files
containing hash values to be verified (in the case of -c option). Wildcard patterns can be used."

const string IG.Script.ScriptAppBase.CryptoGetKey = "GetKey"

const string IG.Script.ScriptAppBase.CryptoHelpGetKey = CryptoGetKey + CryptoHelpGetKeyLastPart
| protected

const string IG.Script.ScriptAppBase.CryptoGetInitializationVector = "GetInitializationVector"

const string IG.Script.ScriptAppBase.CryptoGetInitializationVector1 = "GetIV"

const string IG.Script.ScriptAppBase.CryptoHelpGetInitializationVector = CryptoGetInitializationVector + CryptoHelpGetKeyLastPart
| protected

const string IG.Script.ScriptAppBase.CryptoHelpGetInitializationVector1 = CryptoGetInitializationVector1 + CryptoHelpGetKeyLastPart
| protected

const string IG.Script.ScriptAppBase.CryptoGetSalt = "GetSalt"

const string IG.Script.ScriptAppBase.CryptoHelpGetSalt = CryptoGetSalt + CryptoHelpGetKeyLastPart
| protected

const string IG.Script.ScriptAppBase.CryptoHelpGetKeyLastPart
| protected

const string IG.Script.ScriptAppBase.CryptoTimeKeyGeneration = "TimeKeyGeneration"

const string IG.Script.ScriptAppBase.CryptoHelpTimeKeyGeneration
| protected

const string IG.Script.ScriptAppBase.CryptoConvert = "Convert"

const string IG.Script.ScriptAppBase.CryptoHelpConvert
| protected

Initial value:
= CryptoConvert +
@" <-bfx> <-bf64> <-bfi> input1 <input2> <input3> ...:
Performs conversions of different representations of strings, byte arrays, and
integers. The last converted string is returned.
Example conversions: from byte array in hexadecimal or base64 format, converted
to string or byte arraty in another representation. Integer converted to
hexadecimal or Bas2-64 representation of array of 64 bytes. String converted to
byte array in hexadecimal or Base-64 representation.
Parameters have the following meaning:
input1, input2, input3 ... : one or more string representation of inputs.
Format of representation depends on option parameters below:
-bfx: input is treated as byte array represented by a hexadecimal string.
-bf64: input is treated as byte array in Base-64 representation.
-bfi: input is treated as integer number.
-sf: input is treated as string (which is default).
These options are equivalent in this command:
-bfix and -bfx, -bf64 and -bfi64, -bfi and -bfii, -sf and -sfi
"

const string IG.Script.ScriptAppBase.CryptoAsymKeyInfo = "AsymKeyInfo"

const string IG.Script.ScriptAppBase.CryptoHelpAsymKeyInfo
| protected

Initial value:
= CryptoAsymKeyInfo +
@" :
Prints information about the specified asymetric keys.
"

const string IG.Script.ScriptAppBase.CryptoCertStoreInfo = "CertStoreInfo"

const string IG.Script.ScriptAppBase.CryptoHelpCertStoreInfo
| protected

Initial value:
= CryptoCertStoreInfo +
@" :
Prints information about the specified certificate store on the computer.
"

const string IG.Script.ScriptAppBase.CryptoCertInfo = "CertInfo"

const string IG.Script.ScriptAppBase.CryptoHelpCertInfo
| protected

Initial value:
= CryptoCertInfo +
@" :
Prints information about the specified certificate.
"

const string IG.Script.ScriptAppBase.CryptoAddCertificate = "AddCertificate"

const string IG.Script.ScriptAppBase.CryptoHelpAddCertificate
| protected

Initial value:
= CryptoAddCertificate +
@" :
Adds the specified certificate to the specified certificate store.
"

const string IG.Script.ScriptAppBase.CryptoRemoveCertificate = "RemoveCertificate"

const string IG.Script.ScriptAppBase.CryptoHelpRemoveCertificate
| protected

Initial value:
= CryptoRemoveCertificate +
@" :
Removes the specified certificate from the specified certificate store.
"

const string IG.Script.ScriptAppBase.CryptoAsymTest = "AsymTest"

const string IG.Script.ScriptAppBase.CryptoHelpAsymTest
| protected

Initial value:
= CryptoAsymTest +
@" :
Performs some tests of asymmetric encryption.
"

const string IG.Script.ScriptAppBase.CryptoCleanFiles = "CleanFiles"

const string IG.Script.ScriptAppBase.CryptoHelpCleanFiles
| protected

Initial value:
= CryptoCleanFiles +
@" <-delencrypted> <-deldecrypted> <-delorig> <-delorig> input1 <input2> <input3> ...:
Performs cleaning - deletion of files remaining after cryptographic operatinons.
For example, encryption or decryption sometimes generates files whose paths are the same
as with their originals, but decorated with distinctive extensions. Cleaning can delete these
files, but this is done easily only if the originals still exist.
Parameters have the following meaning:
input1, input2, input3 ... : one or more input files. Files can be specified by
file paths where wildcards are allowed. Cleaning will refear to all files that
are associated with each of the specified files (i.e. input, encrypted - extension .ig_enc,
or decrypted - extension .ig.dec, version).
-deldencrypted: encrypted files will be deleted, i.e. files with the .ig_enc extesdion.
-deldecrypted: decrypted files will be deleted, i.e. files with the .ig_dec extension.
-delorig: original versions of files will be deleted (no distinctive extension).
-delallversions: speciifies thet it is allowed to delete all versions of the specified file.
-yd: eligible files will be deleted without asking for user confirmation.
-nd: no files are will be deleted (all skipped without asking for user confirmation). This
may be useful for just checking which files would be deleted by using a given command.
A number of parameters that specify recursive selecton of files from nested directories
can also be used. See help and example files for details.
"

bool IG.Script.ScriptAppBase._appCryptoCommandsInitialized = false
| protected

List<string> IG.Script.ScriptAppBase.AppSystemNames = new List<string>()
| protected

List of installed system related command names.

List<string> IG.Script.ScriptAppBase.AppSystemHelpStrings = new List<string>()
| protected

List of help strings corresponding to installed system related commands.

List<CommandMethod> IG.Script.ScriptAppBase.AppSystemMethods = new List<CommandMethod>()
| protected

List of methods used to perform system related commmands.

const string IG.Script.ScriptAppBase.SystemRuntimeVersion = "RuntimeVersion"

const string IG.Script.ScriptAppBase.SystemHelpRuntimeVersion = SystemRuntimeVersion + " : Prints version of the runtime environment that application runs on."
| protected

const string IG.Script.ScriptAppBase.SystemComputerName = "ComputerName"

const string IG.Script.ScriptAppBase.SystemHelpComputerName = SystemComputerName + " : Prints and returns the current computer name."
| protected

const string IG.Script.ScriptAppBase.SystemDomainName = "DomainName"

const string IG.Script.ScriptAppBase.SystemHelpDomainName = SystemDomainName + " : Prints and returns the current domain name."
| protected

const string IG.Script.ScriptAppBase.SystemIpAddress = "IpAddress"

const string IG.Script.ScriptAppBase.SystemHelpIpAddress = SystemIpAddress + " : Prints and returns IP address of the current computer."
| protected

const string IG.Script.ScriptAppBase.SystemUserName = "UserName"

const string IG.Script.ScriptAppBase.SystemHelpUserName = SystemUserName + " : Prints and returns the current user name."
| protected

const string IG.Script.ScriptAppBase.SystemSystemInfo = "Info"

const string IG.Script.ScriptAppBase.SystemHelpSystemInfo = SystemSystemInfo + " : Prints and returns basic system info."
| protected

const string IG.Script.ScriptAppBase.SystemMACAddress = "MACAddress"

const string IG.Script.ScriptAppBase.SystemHelpMACAddress = SystemMACAddress + " : Prints and returns the current domain name."
| protected

bool IG.Script.ScriptAppBase._appSystemCommandsInitialized = false
| protected

List<string> IG.Script.ScriptAppBase.AppAssemblyNames = new List<string>()
| protected

List of installed assemblies related command names.

List<string> IG.Script.ScriptAppBase.AppAssemblyHelpStrings = new List<string>()
| protected

List of help strings corresponding to installed assembly related commands.

List<CommandMethod> IG.Script.ScriptAppBase.AppAssemblyMethods = new List<CommandMethod>()
| protected

List of methods used to perform assembly related commmands.

const string IG.Script.ScriptAppBase.AssemblyInfo = "Info"

const string IG.Script.ScriptAppBase.AssemblyInfo1 = "AssemblyInfo"

const string IG.Script.ScriptAppBase.AssemblyHelpInfo
| protected

Initial value:
= AssemblyInfo + " <AssemblyName> : Prints information on the specified assembly."
+ "\n" + " AssemblyName: name of the assembly. If not specified then the information on executable assembly is printed."

const string IG.Script.ScriptAppBase.AssemblyHelpInfo1
| protected

Initial value:
= AssemblyInfo1 + " <AssemblyName> : Prints information on the specified assembly."
+ "\n" + " AssemblyName: name of the assembly. If not specified then the information on executable assembly is printed."

const string IG.Script.ScriptAppBase.AssemblyResources = "Resources"

const string IG.Script.ScriptAppBase.AssemblyResources1 = "ResourceInfo"

const string IG.Script.ScriptAppBase.AssemblyResourcesEmbedded = "ResourcesEmbedded"

const string IG.Script.ScriptAppBase.AssemblyResourcesResx = "ResourcesResx"

const string IG.Script.ScriptAppBase.AssemblyHelpResources
| protected

Initial value:
= AssemblyResources + " <AssemblyName> : Prints information on the specified assembliy's resources."
+ "\n" + " AssemblyName: assembly name. If not specified then the information on executable assembly is printed."

const string IG.Script.ScriptAppBase.AssemblyHelpResources1
| protected

Initial value:
= AssemblyResources1 + " <AssemblyName> : Prints information on the specified assembliy's resources."
+ "\n" + " AssemblyName: assembly name. If not specified then the information on executable assembly is printed."

const string IG.Script.ScriptAppBase.AssemblyHelpResourcesEmbedded
| protected

Initial value:
= AssemblyResourcesEmbedded + " <AssemblyName> : Prints information on the specified assembliy's embedded resources."
+ "\n" + " AssemblyName: assembly name. If not specified then the information on executable assembly is printed."

const string IG.Script.ScriptAppBase.AssemblyHelpResourcesResx
| protected

Initial value:
= AssemblyResourcesResx + " <AssemblyName> : Prints information on the specified assembliy's .resx resources."
+ "\n" + " AssemblyName: assembly name. If not specified then the information on executable assembly is printed."

const string IG.Script.ScriptAppBase.AssemblyReferenced = "ReferencedAssemblies"

const string IG.Script.ScriptAppBase.AssemblyReferenced1 = "Referenced"

const string IG.Script.ScriptAppBase.AssemblyHelpReferenced
| protected

Initial value:
= AssemblyReferenced + @" <recursice includeGAC>: Prints a list of referenced assemblies.
recursive: if true then indirectly referenced assemblies are printed, too. Default is false.
includeGAC: if true (default) then assemblies from Global Assembly Cache are also included."

const string IG.Script.ScriptAppBase.AssemblyHelpReferenced1 = AssemblyHelpReferenced
| protected

const string IG.Script.ScriptAppBase.AssemblyLoaded = "LoadedAssemblies"

const string IG.Script.ScriptAppBase.AssemblyLoaded1 = "Loaded"

const string IG.Script.ScriptAppBase.AssemblyHelpLoaded = AssemblyLoaded + @" : Prints all loaded assemblies."
| protected

const string IG.Script.ScriptAppBase.AssemblyHelpLoaded1 = AssemblyHelpLoaded
| protected

const string IG.Script.ScriptAppBase.AssemblyLoad = "LoadAssemblies"

const string IG.Script.ScriptAppBase.AssemblyLoad1 = "Load"

const string IG.Script.ScriptAppBase.AssemblyInfoLoad = "InfoLoadAssemblies"

const string IG.Script.ScriptAppBase.AssemblyInfoLoad1 = "InfoLoad"

const string IG.Script.ScriptAppBase.AssemblyHelpLoad
| protected

Initial value:
= AssemblyLoad + @" <assembly1 assembly2 ...>: Loads the specified assemblies.
assembly1, assembly2, ...: assembly file names for the assemblies to be loaded."

const string IG.Script.ScriptAppBase.AssemblyHelpLoad1 = AssemblyHelpLoad
| protected

const string IG.Script.ScriptAppBase.AssemblyHelpInfoLoad
| protected

Initial value:
= AssemblyInfoLoad + @" <assembly1 assembly2 ...>: Loads the specified assemblies
for inspection onlly (can not be executed).
assembly1, assembly2, ...: assembly file names for the assemblies to be loaded."

const string IG.Script.ScriptAppBase.AssemblyHelpInfoLoad1 = AssemblyHelpInfoLoad
| protected

bool IG.Script.ScriptAppBase._appAssemblyCommandsInitialized = false
| protected

List<string> IG.Script.ScriptAppBase.AppProcessNames = new List<string>()
| protected

List of installed process-related command names.

List<string> IG.Script.ScriptAppBase.AppProcessHelpStrings = new List<string>()
| protected

List of help strings corresponding to installed process commands.

List<CommandMethod> IG.Script.ScriptAppBase.AppProcessMethods = new List<CommandMethod>()
| protected

List of methods used to perform process-related commmands.

const string IG.Script.ScriptAppBase.ProcessListProcesses = "ListProcesses"

const string IG.Script.ScriptAppBase.ProcessHelpListProcesses
| protected

Initial value:
= ProcessListProcesses + @" <ProcessName> <CaseSensitive> <FullName> <printDetails> :
Lists running processes with specified names.
ProcessName: process name. If not specified then all running processes are listed.
CaseSensitive: whether process name is case sensitive, default is false.
FullName: whether full name must be specified (otherwise substring is enough), default is true."

const string IG.Script.ScriptAppBase.ProcessListApplications = "ListApplications"

const string IG.Script.ScriptAppBase.ProcessHelpListApplications
| protected

Initial value:
= ProcessListApplications + @" <ProcessName> <CaseSensitive> <FullName> <printDetails> :
Lists running applications (processes having main window with title) with specified process names.
ProcessName: process name. If not specified then all running applications are listed.
CaseSensitive: whether process name is case sensitive, default is false.
FullName: whether full name must be specified (otherwise substring is enough), default is true."

const string IG.Script.ScriptAppBase.ProcessListApplicationsByWindow = "ListApplicationsByWindow"

const string IG.Script.ScriptAppBase.ProcessHelpListApplicationsByWindow
| protected

Initial value:
= ProcessListApplicationsByWindow + @" <WindowTitle> <CaseSensitive> <FullName> <printDetails> :
Lists running applications with specified names of main window title.
WindowTitle: main window title of the application. If not specified then all running applications are listed.
CaseSensitive: whether window title is case sensitive, default is false.
FullName: whether full name must be specified (otherwise substring is enough), default is false."

const string IG.Script.ScriptAppBase.ProcessKillProcesses = "KillProcesses"

const string IG.Script.ScriptAppBase.ProcessHelpKillProcesses
| protected

Initial value:
= ProcessKillProcesses + @" <ProcessName> <CaseSensitive> <FullName> <printDetails> :
Kills running processes with specified names.
ProcessName: process name. If not specified then all running processes are killed.
CaseSensitive: whether process name is case sensitive, default is false.
FullName: whether full name must be specified (otherwise substring is enough), default is true."

const string IG.Script.ScriptAppBase.ProcessKillApplications = "KillApplications"

const string IG.Script.ScriptAppBase.ProcessHelpKillApplications
| protected

Initial value:
= ProcessKillApplications + @" <ProcessName> <CaseSensitive> <FullName> <printDetails> :
Kills running applications (processes having main window with title) with specified process names.
ProcessName: process name. If not specified then all running applications are killed.
CaseSensitive: whether process name is case sensitive, default is false.
FullName: whether full name must be specified (otherwise substring is enough), default is true."

const string IG.Script.ScriptAppBase.ProcessKillApplicationsByWindow = "KillApplicationsByWindow"

const string IG.Script.ScriptAppBase.ProcessHelpKillApplicationsByWindow
| protected

Initial value:
= ProcessKillApplicationsByWindow + @" <WindowTitle> <CaseSensitive> <FullName> <printDetails> :
Kills running applications with specified names of main window title.
WindowTitle: main window title of the application. If not specified then all running applications are killed.
CaseSensitive: whether window title is case sensitive, default is false.
FullName: whether full name must be specified (otherwise substring is enough), default is false."

bool IG.Script.ScriptAppBase._appProcessCommandsInitialized = false
| protected

List<string> IG.Script.ScriptAppBase.AppDataStructuresNames = new List<string>()
| protected

List of installed data structure - related demo command names.

List<string> IG.Script.ScriptAppBase.AppDataStructuresHelpStrings = new List<string>()
| protected

List of help strings corresponding to the installed data structure - related demo commands.

List<CommandMethod> IG.Script.ScriptAppBase.AppDataStructuresMethods = new List<CommandMethod>()
| protected

List of methods used to perform data structure - related demo commmands.

bool IG.Script.ScriptAppBase._appDataStructuresCommandsInitialized = false
| protected

## Property Documentation

virtual bool IG.Script.ScriptAppBase.IsAddRunFileByScriptCommand
| get set

Whether or not the Run command is installed on the script's interpreter.

The documentation for this class was generated from the following files:

- igbase/0guests/Tako78/scripts/ScriptAppBase1.cs
- igbase/interpreters/scriptloader/scripts/ScriptAppBase.cs